#include <bits/stdc++.h>
using namespace std;


void solve() {
    int N, K;
    string s;
    cin>>N>>K>>s;
    int pfx[N][K];
    memset(pfx, 0, sizeof(pfx));
    for(int i=0;i<N;++i) {
        pfx[i][s[i] - 'a']++;
        if (i > 0) {
            for(int j=0;j<K;++j)pfx[i][j] += pfx[i-1][j];
        }
    }

    for(int i=0;i<N;++i) {
        int ans = INT_MAX;
        for(int j=0;j<K;++j) {
            ans = min(ans, pfx[i][j]);
        }

        cout<<ans + 1;
        if (i == N-1)cout<<"\n";
        else cout<<" ";
    }
}

int main(void){
    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}